
//#define DEBUG_MODE_OFF

//#ifdef DEBUG_MODE_OFF
#include <OneWire.h>
//#include <i2cmaster.h>
#include <DallasTemperature.h>
#define ONE_WIRE_BUS_1 12
#include <Adafruit_MLX90614.h>
#define I2C_ADDR 0x27 //I2C adress, you should use the code to scan the adress first (0x27) here
Adafruit_MLX90614 mlx = Adafruit_MLX90614();
//---------------------
const int DP1 = 2;
const int DP2 = 3; 
const int DP3 = 4; 
const int DP4 = 5; 
const int DP5 = 6; 
const int DP6 = 7; 
const int DP7 = 8; 
const int DP8 = 9; 
const int DP9 = 10; 
const int RELAY = 11;
OneWire oneWire_1(ONE_WIRE_BUS_1);
DallasTemperature sensor_1(&oneWire_1);
//byte ds18b20_addr[8];  

//-------------------
int DP1_State = 0; 
int DP2_State = 0;
int DP3_State = 0;
int DP4_State = 0;
int DP5_State = 0;
int DP6_State = 0;
int DP7_State = 0;
int DP8_State = 0;
int DP9_State = 0;
int nbtuile = 0;
int nbtuile2 = 0;
int presetnbtuile = 6;
float deltatemp = 0;

float sensor1 = 0;
float MLX90614 = 0;
float delta_celsius = 0;
float avg_delta_celsius = 21.5;

int watchdograin = 0;
int watchdogcloud = 0;
int withcloud = 0;
int presetavg = 300;

//char myString [] = { "Principalement clair 1","Peu de nuage ou nuages élevés 2","Quelque nuages 3","Partielement nuageux 4","Très nuageux 5","Couvert ou brouillard 6"};
int i = 1;
//-------------------
void setup(void) {
    Serial.begin(9600);
mlx.begin();
sensor_1.begin();
  
  // Output:
  pinMode(RELAY, OUTPUT);
  
  // Input:
  pinMode(DP1, INPUT);
  pinMode(DP2, INPUT);
  pinMode(DP3, INPUT);
  pinMode(DP4, INPUT);
  pinMode(DP5, INPUT);
  pinMode(DP6, INPUT);
  pinMode(DP7, INPUT);
  pinMode(DP8, INPUT);
  pinMode(DP9, INPUT);
 
}


void loop(void) {


  sensor_1.requestTemperatures();
    
  byte RX = 0; // variable contenant le message venent du port serie
    int RXdispo = 0; // un RX est arrivé

RXdispo = Serial.available();
  // read the state of the DP value:
  DP1_State = digitalRead(DP1);
  DP2_State = digitalRead(DP2);
  DP3_State = digitalRead(DP3);
  DP4_State = digitalRead(DP4);
  DP5_State = digitalRead(DP5);
  DP6_State = digitalRead(DP6);
  DP7_State = digitalRead(DP7);
  DP8_State = digitalRead(DP8);
  DP9_State = digitalRead(DP9);

 nbtuile = DP1_State + DP2_State + DP3_State + DP4_State + DP5_State + DP6_State + DP7_State + DP8_State + DP9_State ;
 nbtuile2 = abs(nbtuile - 9);

   sensor1 = sensor_1.getTempCByIndex(0) ;
   MLX90614 = mlx.readObjectTempC();
    delta_celsius = abs(sensor1 - MLX90614);
    if ( presetavg == 300){
      delay(10);
     avg_delta_celsius = ((avg_delta_celsius*299.0) + delta_celsius)/300.0;     
    }
    if ( presetavg == 600){
      delay(10);
     avg_delta_celsius = ((avg_delta_celsius*599.0) + delta_celsius)/600.0;
    }
    if ( presetavg == 900){
     avg_delta_celsius = ((avg_delta_celsius*899.0) + delta_celsius)/900.0;
    }
     if ( presetavg == 1800){
     avg_delta_celsius = ((avg_delta_celsius*1799.0) + delta_celsius)/1800.0;
    }
    //avg_delta_celsius = ((avg_delta_celsius*299.0) + delta_celsius)/300.0;

 ////////////////////////////////:  
   if (nbtuile2 >= presetnbtuile) 
   { 
    watchdograin = 1;
   }else{
    watchdograin = 0;
   }
//////////////////////
   if (deltatemp > avg_delta_celsius ) 
   {    
    watchdogcloud = 1;
   }else{
    watchdogcloud = 0;
  
   }

 //////////////avec detecteur de nuage///////////////////
  if ( withcloud == 1 )  {         
  delay(10);  
   if (watchdograin == 0 && watchdogcloud == 0 ) {   
    digitalWrite(RELAY, HIGH);   
   }else{
   digitalWrite(RELAY, LOW);
   }
}
////////////////sans detecteur de nuage//////////////////////
if (withcloud == 0 ) {
  delay(10);
  if (watchdograin == 0 ){
    digitalWrite(RELAY, HIGH);
  }else{
    digitalWrite(RELAY, LOW);
  }
}

       delay (500);
 ////////////////nb tuiles pour detection pluie/////////////////// 
 if (avg_delta_celsius > 28)
 {
  i = 1;
 }
 else if( avg_delta_celsius<28 && avg_delta_celsius>24)
 {
  i=2;
 }
  else if( avg_delta_celsius<24 && avg_delta_celsius>19)
 {
  i=3;
 }
  else if( avg_delta_celsius<19 && avg_delta_celsius>17)
 {
  i=4;
 }
  else if( avg_delta_celsius<17 && avg_delta_celsius>14)
 {
  i=5;
 }
  else if( avg_delta_celsius<14 && avg_delta_celsius>4)
 {
  i=6;
 }
   else if( avg_delta_celsius<4)
 {
  i=7;
 }
 ///////////COM JSON//////////////////
    Serial.print("{\"nbtuile2\":");
    Serial.print(nbtuile2);
    Serial.print(",\"presetnbtuile\":");
    Serial.print(presetnbtuile);
    Serial.print(",\"deltatemp\":");
    Serial.print(deltatemp);
    Serial.print(",\"ds18b20\":");
    Serial.print(sensor_1.getTempCByIndex(0));  
    Serial.print(",\"mlx\":");
    Serial.print(mlx.readAmbientTempC()); 
    Serial.print(",\"mlx2\":");
    Serial.print(mlx.readObjectTempC());
    Serial.print(",\"deltatemp2\":");
    Serial.print(delta_celsius);
    Serial.print(",\"avgdeltatemp2\":");
    Serial.print(avg_delta_celsius);
    Serial.print(",\"sensor1\":");
    Serial.print(sensor1);
    Serial.print(",\"MLX90614\":");
    Serial.print(MLX90614);
    Serial.print(",\"wdrain\":");
    Serial.print(watchdograin);
    Serial.print(",\"wdcloud\":");
    Serial.print(watchdogcloud);
    Serial.print(",\"meteo\":");
    Serial.print(i);
    Serial.print(",\"presetavg\":");
    Serial.print(presetavg);
    Serial.println("}");
/////////////////////////////////////////RX/////////////////////////////////
     if (RXdispo > 0)
    {
      RX = Serial.read();

      switch (RX)
      {
        
          case '1' :
          presetnbtuile = 1;
     break;
          case '2' :
          presetnbtuile = 2;
     break;
          case '3' :
          presetnbtuile = 3;
     break;
          case '4' :
         presetnbtuile = 4;
     break;
          case '5' :
          presetnbtuile = 5;
     break;
          case '6' :
          presetnbtuile = 6;
     break;
          case '7' :
          presetnbtuile = 7;
     break;
          case '8' :
         presetnbtuile = 8;
     break;
          case '9' :
          presetnbtuile = 9;
     break;
 //////////////////average delta temp//////////////////////
                         case 'A' :
         deltatemp = 18;
             break;
                         case 'B' :
         deltatemp = 17.5;
             break;
                         case 'C' :
         deltatemp = 17;
             break;
                         case 'D' :
         deltatemp = 16.5;
             break;
                         case 'E' :
         deltatemp = 16;
             break;
                         case 'F' :
         deltatemp = 15.5;
             break;
                         case 'G' :
         deltatemp = 15;
             break;
                         case 'H' :
         deltatemp = 14.5;
             break;
                         case 'I' :
         deltatemp = 14;
             break;
                         case 'J' :
         deltatemp = 13.5;
             break;
                         case 'K' :
         deltatemp = 13;
             break;
                         case 'L' :
         deltatemp = 12.5;
             break;
                         case 'M' :
         deltatemp = 12;
             break;
                         case 'N' :
         deltatemp = 11.5;
             break;
                         case 'O' :
         deltatemp = 11;
             break;
                         case 'P' :
         deltatemp = 10.5;
             break;
                         case 'Q' :
         deltatemp = 10;
             break;
                         case 'R' :
         deltatemp = 9.5;
             break;
                         case 'S' :
         deltatemp = 9;
             break;
                         case 'T' :
         deltatemp = 8.5;
             break;
                         case 'U' :
         deltatemp = 8;
             break;
                         case 'V' :
         deltatemp = 7.5;
             break;
                         case 'W' :
         deltatemp = 7;
             break;
                         case 'X' :
         deltatemp = 6.5;
             break;
                         case 'Y' :
         deltatemp = 6;
             break;
                         case 'Z' :
         deltatemp = 5.5;
             break;
                         case '!' :
         deltatemp = 5;
             break;
                         case '?' :
         deltatemp = 4.5;
             break;
                         case '/' :
         deltatemp = 4;
             break;
  ////////////////////////////////////
                         case '#' :
         withcloud = 1;
             break;
                         case '@' :
        withcloud = 0;
             break;
 /////////////////////////////////////
                          case '~' :
       presetavg = 300;
             break;
                          case '[' :
        presetavg = 600;
             break;
                          case ']' :
        presetavg = 900;
             break;
                          case '%' :
        presetavg = 1800;
             break;
      }
   }
}
